/*
 * A Szoftver Laboratrium 3 cm trgy 2008. december 01-i NagyZH nagyfeladatnak megoldsa.
 * Ksztette: Gerg Mrton - 2008. 12. 02.
 * Det: Control rteg
 */

import java.awt.event.*;

public class Control implements ActionListener, KeyListener, WindowListener {
	Model model;
	View view;

	Control(int widthHeight) {
		model = new Model(widthHeight);
		view = new View(model, this);
	}

	// Ez a szl a szavak mozgatsrt felels
	class MovingThread extends Thread {
		public void run() {
			while (true) {
				if (model.isOut()) {
					model.createNew();
					view.clearInput();
				}
				model.move();
				view.repaint();
				try {
					sleep(100);
				} catch (InterruptedException e) {
				}
			}
		}
	}

	MovingThread movingThread = new MovingThread();

	// Start gomb lenyomsnak esemnye
	public void actionPerformed(ActionEvent ae) {
		model.createNew();
		movingThread.start();
	}

	// Billenty letse esemny - az entert figyelem
	public void keyPressed(KeyEvent ke) {
		if (ke.getKeyCode() == ke.VK_ENTER) {
			if (model.getCurrentWord().compareTo(view.getInput()) == 0) {
				model.setOk();
			} else {
				model.setWrong();
			}
			view.clearInput();
		}
	}

	// Ablakbezrs esemny
	public void windowClosing(WindowEvent we) {
		System.exit(0);
	}

	public static void main(String[] args) {
		Control control = new Control(300);
	}

	// Ezekre a metdusokra nincs szksgem, h res trzs fgv-eket ksztek
	public void keyReleased(KeyEvent ke) {
	}

	public void keyTyped(KeyEvent ke) {
	}

	public void windowDeactivated(WindowEvent we) {
	}

	public void windowActivated(WindowEvent we) {
	}

	public void windowDeiconified(WindowEvent we) {
	}

	public void windowIconified(WindowEvent we) {
	}

	public void windowOpened(WindowEvent we) {
	}

	public void windowClosed(WindowEvent we) {
	}
}